data = GameLogic.getStaticGameData(gamelogic)
director = GameLogic.getGameDirector(gamelogic)

blacklist = {}
blacklist[68592181] = true

locs = StaticGameData.getLocationIds(data)
for locationId in StaticGameData.dataIds(locs) do
  if blacklist[locationId] == true then
    print("skipping blacklisted location: ", locationId, "\n")
  else
	missionSets = StaticGameData.getMissionEntitySets(data, locationId)
	  
	for missionSet in StaticGameData.dataIds(missionSets)  do
		missionId = StaticGameData.getMissionIdFromMissionSet(data, missionSet)
		if StaticGameData.missionHasOwner(missionId) == true then
			sequence = GameDirectorSequences.TestLocation()
			request = GameStateChangeRequest.createRequest(sequence)
			missionInstanceData = MissionInstantiationData.makeMissionInstantiationData(locationId, missionId, missionSet, 0, true)
			GameStateChangeRequest.setInstantiationData(request, missionInstanceData)
			GameStateChangeRequest.setName(request, "testscript -- load location and mission ", locationId, "\n")
			GameDirector.requestGameStateChange(director, request)
		end
	end
	 
  end
end

function waitForExit()
  function gameDirectorDone()
    return not GameDirector.hasCurrentRequest(director)
  end
  waitUntil(gameDirectorDone)
  os.exit(0)
end

executeAsync(waitForExit)
