data = GameLogic.getStaticGameData(gamelogic)
director = GameLogic.getGameDirector(gamelogic)

blacklist = {}
blacklist[68592181] = true
blacklist[1178680929] = true
blacklist[1864161091] = true
blacklist[2486580805] = true
blacklist[2538649459] = true
paragonOfPerformanceMissionId = 2262322435

count = 0
locs = StaticGameData.getLocationIds(data)
for locationId in StaticGameData.dataIds(locs) do
  if blacklist[locationId] == true then
    print("skipping blacklisted location: ", locationId, "\n")
  else
  	paragonOfPerformanceMissionAvailable = StaticGameData.locationHasMissionEntitySet(data, locationId, paragonOfPerformanceMissionId)
  	if paragonOfPerformanceMissionAvailable == false then
  	  print("skipping location ", locationId, " because mission ", paragonOfPerformanceMissionId, " has no entity set", "\n")
  	else
	  sequence = GameDirectorSequences.TestLocation()
	  request = GameStateChangeRequest.createRequest(sequence)
    --request.setOverrideDangerLevel(math.random(14, 256))
	  
	  missionSetUid = StaticGameData.getRandomMissionEntitySetId(data, paragonOfPerformanceMissionId, locationId)
	  missionInstanceData = MissionInstantiationData.makeMissionInstantiationData(locationId, paragonOfPerformanceMissionId, missionSetUid, 0, true)
	  GameStateChangeRequest.setInstantiationData(request, missionInstanceData)
	  GameStateChangeRequest.setName(request, "testscript -- load location ", locationId, "\n")

	  GameDirector.requestGameStateChange(director, request)

    count = count + 1
	end
  end
  if count > 20 then
    break
  end
end



function waitForExit()
  function gameDirectorDone()
    return not GameDirector.hasCurrentRequest(director)
  end
  waitUntil(gameDirectorDone)
  Test.notifyEnd()
  os.exit(0)
end

executeAsync(waitForExit)
