data = GameLogic.getStaticGameData(gamelogic)
director = GameLogic.getGameDirector(gamelogic)

locs = StaticGameData.getLocationIds(data)
locationIds = StaticGameData.locationIds(locs)

executeAsync(function(loadLocation)

	for locationId in locationIds do
		sequence = GameDirectorSequences.ChangeLocation()
		request = GameStateChangeRequest.createRequest(sequence)
		GameStateChangeRequest.setLocationId(request, locationId)
		GameStateChangeRequest.setName(request, "Valgrind -- load location " .. locationId)

		GameDirector.requestGameStateChange(director, request)

		waitUntil(function()
			return GameDirector.hasCurrentRequest(director)
		end)
	end
end)

--os.exit()
