waitingCoroutines = {}

pendingWaits = {}

numPendingWaits = 0

function waitForNextFrame() -- suspends execution of the current coroutine until the next frame.
	local co = coroutine.running()
	assert(co ~= nil, "The main thread cannot wait!")

	local index = #pendingWaits + 1
	pendingWaits[index] = co;
	numPendingWaits = numPendingWaits + 1

	coroutine.yield(co)
end

function hasWaitingCoroutine()
	return numPendingWaits == 0
end

function waitUntil(condition) -- executes the function 'condition' each frame and yields each frame until the function returns true. 'condition' must take no arguments.
	repeat
		local conditionMet = condition()
		waitForNextFrame()

	until conditionMet
end

function resumeAll_() -- resumes all active coroutines. To be called internally by the engine only!!! DO NOT CALL THIS YOURSELF!!!!!
	--swap waiting lists around
	swapWaits = waitingCoroutines;
	waitingCoroutines = pendingWaits;
	pendingWaits = swapWaits;

	for i, co in ipairs(waitingCoroutines) do
		numPendingWaits = numPendingWaits - 1
		coroutine.resume(co)
	end

	waitingCoroutines = {}
end

function executeAsync(func) -- starts a function in a coroutine which is able to suspend and resume execution.
	local co = coroutine.create(func)
	return coroutine.resume(co)
end
